unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TControl_Panel = class(TForm)
    Button1: TButton;
    Button2: TButton;
    StaticText5: TStaticText;
    EditX1: TEdit;
    EditX2: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    StaticText2: TStaticText;
    StaticText7: TStaticText;
    CheckBox1: TCheckBox;
    StaticText3: TStaticText;
    EditEq: TEdit;
    StaticText1: TStaticText;
    StaticText4: TStaticText;
    EditStep: TEdit;
    EditC1: TEdit;
    EditC2: TEdit;
    StaticText6: TStaticText;
    StaticText8: TStaticText;
    EditIso: TEdit;
    StaticText9: TStaticText;
    StaticText10: TStaticText;
    Button3: TButton;
    ColorIndicator: TImage;
    Button4: TButton;
    ColorDialog1: TColorDialog;
    
    procedure Implicit_Speed(Sender: TObject);
    procedure Finish(Sender: TObject);
    procedure SetDraw2D(Sender: TObject);
    procedure SetStop(Sender: TObject);
    procedure Clear(Sender: TObject);
    procedure ColorChange(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    Eq,ErrorReport:String;
    Step,NoOfIso  :Integer;
    procedure Setting;
  end;

var
  Control_Panel: TControl_Panel;
  Stop         :Boolean;
implementation

uses Graph2d_2005;

{$R *.DFM}

procedure TControl_Panel.Setting;
var Number:Double;
    Code :Integer;
begin
   Eq:=EditEq.Text;
   Val(EditX1.Text,Number,Code);Draw2D.x1:=Number;
   Val(EditX2.Text,Number,Code);Draw2D.x2:=Number;
   Val(EditY1.Text,Number,Code);Draw2D.y1:=Number;
   Val(EditY2.Text,Number,Code);Draw2D.y2:=Number;
   Val(EditC1.Text,Number,Code);Draw2D.k1:=Number;
   Val(EditC2.Text,Number,Code);Draw2D.k2:=Number;
   Val(EditStep.Text,Number,Code);Step:=Trunc(Number);
   Val(EditIso.Text,Number,Code);NoOfIso:=Trunc(Number);
   Stop:=False;
end;

procedure TControl_Panel.Implicit_Speed(Sender: TObject);
  var h1,h2,h3,h4      :Double;
      WhatLine         :Byte;
      Expression       :TExpression;

  Procedure HorizHalf(x1,x2,Level:Double;var Result:Double);
  var i    :Integer;
      a,b,cPo,MemX,MemY,h1,h2:Double;
  begin
     a:=x1;b:=x2;
     MemX:=Draw2D.x;MemY:=Draw2D.y;
     Draw2D.Y:=Level;
     For i:=1 to Trunc(Step) do
     begin
       cPo:=(a+b)/2;
       Draw2D.x:=a;
       h1:=Draw2D.PostCalc(Expression,ErrorReport);
       Draw2D.x:=cPo;
       h2:=Draw2D.PostCalc(Expression,ErrorReport);
       if h1*h2<0 then b:=cPo else a:=cPo;
     end;
     Result:=cPo;Draw2D.x:=MemX;Draw2D.y:=MemY;
  end;

  Procedure VertHalf(y1,y2,Level:Double;var Result:Double);
  var i    :Integer;
      a,b,cPo,MemX,MemY,h1,h2:Double;
  begin
     a:=y1;b:=y2;
     MemX:=Draw2D.x;MemY:=Draw2D.y;
     Draw2D.x:=Level;
     For i:=1 to Trunc(Step) do
     begin
       cPo:=(a+b)/2;
       Draw2D.y:=a;
       h1:=Draw2D.PostCalc(Expression,ErrorReport);
       Draw2D.y:=cPo;
       h2:=Draw2D.PostCalc(Expression,ErrorReport);
       if h1*h2<0 then b:=cPo else a:=cPo;
     end;
     Result:=cPo;
     Draw2D.x:=MemX;Draw2D.y:=MemY;
  end;

  begin
    Setting;
    With Draw2D do
    begin
     Scale(x1,x2,y1,y2);
     XScale(x1,x2,0,200,0,0);
     YScale(y1,y2,0,200,0,0);
     hx:=Step*(x2-x1)/Image1.Width;
     hy:=Step*(y2-y1)/Image1.Height;
     hk:=(k2-k1)/NoOfIso;
     Red:=0;Green:=0;Blue:=200;
   x:=x1;
   Expression:=PreCalc(Eq,ErrorReport);
      Repeat
        y:=y1;
        Repeat
        k:=k1;
        Repeat
          WhatLine:=0;
          h1:=PostCalc(Expression,ErrorReport);y:=y+hy;
          h2:=PostCalc(Expression,ErrorReport);x:=x+hx;
          h3:=PostCalc(Expression,ErrorReport);y:=y-hy;
          h4:=PostCalc(Expression,ErrorReport);x:=x-hx;
          if h1*h2<0
          then begin
              WhatLine:=1;
              A[1]:=x;VertHalf(y,y+hy,x,A[2]);
              end;
          if h2*h3<0
          then begin
              WhatLine:=WhatLine+2;
              HorizHalf(x,x+hx,y+hy,B[1]);B[2]:=y+hy
              end;
         if h3*h4<0
         then begin
              WhatLine:=WhatLine+4;
              C[1]:=x+hx;VertHalf(y,y+hy,x+hx,C[2]);
              end;
         if h4*h1<0
         then begin
              WhatLine:=WhatLine+8;
              HorizHalf(x,x+hx,y,D[1]);D[2]:=y
              end;
          Case WhatLine of
             3:Line(A,B,0,0,200);
             5:Line(A,Draw2D.C,0,0,200);
             9:Line(A,D,0,0,200);
             6:Line(B,Draw2D.C,0,0,200);
            10:Line(B,D,0,0,200);
            12:Line(Draw2D.C,D,0,0,200);
            end;
          k:=k+hk;
         Until k>k2;
         y:=y+hy;
        Until y>y2;
        x:=x+hx;
      until x>x2;
      Image1.Repaint;
   end;
end;

procedure TControl_Panel.Finish(Sender: TObject);
begin
  Draw2D.Visible:=False;Halt;
end;

procedure TControl_Panel.SetDraw2D(Sender: TObject);
begin
  Application.CreateForm(TDraw2D, Draw2D);
  With Draw2D do
  begin
    Top:=100;Left:=350;
    ClientWidth:=500;ClientHeight:=500;
    InitImage(500,500);ClearImage(255,255,255);
    Caption:='Contour Lines';
    Visible:=True;
    Blue:=200;Green:=0;Red:=0;
    ColorIndicator.Canvas.Pen.Color:=Red+256*Green+256*256*Blue;
    ColorIndicator.Canvas.Brush.Color:=Red+256*Green+256*256*Blue;
    ColorIndicator.Canvas.Rectangle(0,0,ColorIndicator.Width,ColorIndicator.Height);
  end;
end;

procedure TControl_Panel.SetStop(Sender: TObject);
begin
   Stop:=True;
end;

procedure TControl_Panel.Clear(Sender: TObject);
begin
   Draw2D.ClearImage(255,255,255);
end;


procedure TControl_Panel.ColorChange(Sender: TObject);
begin
 if ColorDialog1.Execute then
  begin
    Draw2D.Blue:=ColorDialog1.Color div (256*256);
    Draw2D.Green:=(ColorDialog1.Color - 256*256*Draw2D.Blue) div 256;
    Draw2D.Red:=ColorDialog1.Color - 256*256*Draw2D.Blue - 256*Draw2D.Green;
  end;
  ColorIndicator.Canvas.Pen.Color:=ColorDialog1.Color;
  ColorIndicator.Canvas.Brush.Color:=ColorDialog1.Color;
  ColorIndicator.Canvas.Rectangle(0,0,ColorIndicator.Width,ColorIndicator.Height);
end;

end.
